import pandas as pd
import matplotlib.pyplot as plt
import numpy as np
import os
import math

#font = {'family' : 'normal',
#        'weight' : 'bold',
#        'size'   : 22}

#plt.rc('font', **font)

data = dict()

for root,dirnames,filenames in os.walk('Data/CSV'):
	for filename in filenames:
		path = root + "/" + filename

		Bio = pd.read_csv(path, nrows= 0)

		df = pd.read_csv(path, header = None, skiprows= [0], index_col= [1])
		df.columns = ["Training Session","Power","Pos1X","Pos1Y","Pos1Z","Vel1X","Vel1Y","Vel1Z","Pos2X","Pos2Y","Pos2Z","Vel2X","Vel2Y","Vel2Z","Current Score","Pos Score"]
		
		#df["Vel Score"] = pd.rolling_mean( 100 * np.exp(-1 * pow( (np.sqrt(pow(df["Vel2Y"],2) + pow(df["Vel2Z"],2) ) / np.sqrt(pow(df["Vel1Y"],2) + pow(df["Vel1Z"],2) )) -  float(Bio.columns[2]),2)   ), 40)
		df["Vel Score"] = ( 100 * np.exp(-1 * pow(    pd.rolling_mean(np.sqrt(pow(df["Vel2Y"],2) + pow(df["Vel2Z"],2) ),40) / pd.rolling_mean(np.sqrt(pow(df["Vel1Y"],2) + pow(df["Vel1Z"],2) ),40) -  float(Bio.columns[2]),2)   ))


		df["Vel Score"].where(df["Training Session"]==3, other = 0, inplace = True)

		df["Total Score"] = (df["Vel Score"] * 0.5) + (df["Pos Score"] * 0.5)
		df["PCT Change"] = df["Total Score"].pct_change(1)
		df.index = df.index/1000

		df = df.drop(columns=["Pos1X","Pos1Y","Pos1Z","Vel1X","Vel1Y","Vel1Z","Pos2X","Pos2Y","Pos2Z","Vel2X","Vel2Y","Vel2Z"])

		data[Bio.columns[0]] = [Bio.columns[1], Bio.columns[2],df]

		




def Plot_data():
	for i,[k,v] in enumerate(data.items()):
		
		fig = plt.figure()




		#Axis 1 for scores
		ax1 = plt.subplot2grid((2,1), (0,0), rowspan = 1, colspan=1)
		ax1.plot(v[2]["Pos Score"], label = "R. Pos Score" , linewidth = 1, color = 'm', alpha = 0.5)
		ax1.plot(v[2]["Vel Score"], label = "R. Vel Score" ,linewidth = 1, alpha = 0.5)
		ax1.plot(v[2]["Total Score"], label = "Total Score", linewidth = 3, alpha = 0.6)
		ax1.plot([],[], label = "Training Power" , color = 'b', alpha=0.3)
		ax1.fill_between(v[2].index ,0,  v[2]["Power"],where =(v[2]["Training Session"] == 1) , facecolor = 'b', alpha=0.3)
		ax1.grid(True, linestyle='dotted')

		plt.ylabel("Score")
		plt.legend(loc=2, prop={'size': 6})
		plt.title("Test Subject "+ str(i+1))

		#Axis 2 for Percent change
		ax2 = plt.subplot2grid((2,1), (1,0), rowspan = 1, colspan=1, sharex=ax1 )
		ax2.plot([],[], color = 'r', alpha=0.5, label = "Negative % Change" )
		ax2.plot([],[], color = 'g', alpha=0.5, label = "Positive % Change" )
		ax2.fill_between(v[2].index ,0,  v[2]["PCT Change"],where = (v[2]["PCT Change"]<0), facecolor = 'r', alpha=0.5)
		ax2.fill_between(v[2].index ,0,  v[2]["PCT Change"],where = (v[2]["PCT Change"]>0), facecolor = 'g', alpha=0.5)
		ax2.set_ylim(-0.02,0.02)
		ax2.grid(True, linestyle='dotted')

		plt.xlabel("time(s)")
		plt.ylabel("Percentage Change")
		plt.legend(loc=2, prop={'size': 6})


	plt.show()


def find_Correlation():

	for i,[k,v] in enumerate(data.items()):
		for x in range(i+1,len(data.keys())):
			print( "The correlation of", str(list(data.keys())[i]), "with", str(list(data.keys())[x]),"=", data[list(data.keys())[i]][2]["Total Score"].corr(data[list(data.keys())[x]][2]["Total Score"] ))



Plot_data()
find_Correlation()